import { csv, json } from 'd3';
import { feature } from 'topojson';

export const loadAndProcessData = () =>
	Promise.all([
		csv('test_csv.csv'),
		json('https://raw.githubusercontent.com/deldersveld/topojson/master/countries/china/china-provinces.json')
	]).then(([csvData, topoJSONdata]) => {
		const china_map = feature(topoJSONdata, topoJSONdata.objects.CHN_adm1);
  	const provinceName = csvData.reduce((accumulator, d) => {
    	accumulator[d.ID] = d;
      return accumulator;
    }, {});
    
    china_map.features.forEach(d => {
    	Object.assign(d.properties, provinceName[d.properties.ID_1]);
    });
		return china_map;
	});